#!/bin/sh

echo regression test

./xml2ulxr  --gen-client --file-name=$1  --dest-dir=$2/new-meth/  --gen-class=UlxrIdlTest
./xml2ulxr  --gen-server --file-name=$1  --dest-dir=$2/new-meth/  --gen-class=UlxrIdlTest

SRC="\".*/stubber/ulxr2xml/"
sed -e s:"$SRC":\":g $2/new-meth/UlxrIdlTest_ulxr_client.h  >new-UlxrIdlTest_ulxr_client.h.tmp
sed -e s:"$SRC":\":g $2/orig-meth/UlxrIdlTest_ulxr_client.h >orig-UlxrIdlTest_ulxr_client.h.tmp

sed -e s:"$SRC":\":g $2/new-meth/UlxrIdlTest_ulxr_server.h  >new-UlxrIdlTest_ulxr_server.h.tmp
sed -e s:"$SRC":\":g $2/orig-meth/UlxrIdlTest_ulxr_server.h >orig-UlxrIdlTest_ulxr_server.h.tmp

# -----

echo "Client files.."

echo diff new-meth/UlxrIdlTest_ulxr_client_user.cpp
diff $2/new-meth/UlxrIdlTest_ulxr_client_user.cpp $2/orig-meth/UlxrIdlTest_ulxr_client_user.cpp || return 1

echo diff new-meth/UlxrIdlTest_ulxr_client.cpp
diff $2/new-meth/UlxrIdlTest_ulxr_client.cpp      $2/orig-meth/UlxrIdlTest_ulxr_client.cpp      || return 1

echo diff new-meth/UlxrIdlTest_ulxr_client.h
diff new-UlxrIdlTest_ulxr_client.h.tmp    orig-UlxrIdlTest_ulxr_client.h.tmp    || return 1

# -----

echo "Server files.."

echo diff new-meth/UlxrIdlTest_ulxr_server_user.cpp
diff $2/new-meth/UlxrIdlTest_ulxr_server_user.cpp $2/orig-meth/UlxrIdlTest_ulxr_server_user.cpp || return 1

echo diff new-meth/UlxrIdlTest_ulxr_server.cpp
diff $2/new-meth/UlxrIdlTest_ulxr_server.cpp      $2/orig-meth/UlxrIdlTest_ulxr_server.cpp      || return 1

echo diff new-meth/UlxrIdlTest_ulxr_server.h
diff new-UlxrIdlTest_ulxr_server.h.tmp    orig-UlxrIdlTest_ulxr_server.h.tmp         || return 1



